﻿(function ($) {
    jQuery.baseAjax = {
        defaults: {
            url: "",
            type: "POST",
            dataType: "json",
            contentType: "application/x-www-form-urlencoded",
            cache: false,
            async: true,
        },
        settings: {
        },

        init: function (options) {
            options = options || {};
            this.settings = $.extend({}, this.defaults, options);
        },

        //Do ajax action base on anonymous object parameter
        doAjax: function (paraObj, successCallback, errorCallback, completeCallbacks) {

            var paraStr = "";
            for (var paraName in paraObj) {
                if (paraStr == "")
                    paraStr = paraName + "=" + paraObj[paraName];
                else 
                    paraStr += "&" + paraName + "=" + paraObj[paraName];
            }

            $.ajax({
                url: this.settings.url,
                type: this.settings.type,
                contentType: this.settings.contentType,
                data: paraStr,
                dataType: this.settings.dataType,
                cache: this.settings.cache,
                async: this.settings.async,
                success: function (d) {
                    if (typeof successCallback == "function")
                        successCallback(d);
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    if (typeof errorCallback == "function")
                        errorCallback(jqXHR, textStatus, errorThrown);
                },
                complete: function () {
                    if (typeof completeCallback == "function")
                        completeCallback();
                }
            });
        },

        //Do ajax action base on entity object parameter
        doAjaxAction: function (requestObj, successCallback, errorCallback, completeCallback) {
            $.ajax({
                url: this.settings.url,
                type: this.settings.type,
                contentType: "application/json;charset=utf-8",
                data: JSON.stringify(requestObj),
                dataType: this.settings.dataType,
                cache: this.settings.cache,
                async: this.settings.async,
                success: function (d) {
                    if (typeof successCallback == "function")
                        successCallback(d);
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    if (typeof errorCallback == "function")
                        errorCallback(jqXHR, textStatus, errorThrown);
                },
                complete: function () {
                    if (typeof completeCallback == "function")
                        completeCallback();
                }
            });
        }
    };

})(jQuery);